import { useState, useCallback } from 'react';

var useAsyncLoading = function useAsyncLoading(defaultValue) {
  if (defaultValue === void 0) {
    defaultValue = false;
  }
  var _useState = useState(defaultValue),
    loading = _useState[0],
    updateLoading = _useState[1];
  var enable = useCallback(function () {
    return updateLoading(true);
  }, []);
  var disable = useCallback(function () {
    return updateLoading(false);
  }, []);
  var toggle = useCallback(function () {
    return updateLoading(function (state) {
      return !state;
    });
  }, []);
  var registerPromise = useCallback(function (promise) {
    try {
      enable();
      return Promise.resolve(promise["finally"](disable));
    } catch (e) {
      return Promise.reject(e);
    }
  }, [enable, disable]);
  return [loading, {
    registerPromise: registerPromise,
    toggle: toggle,
    update: updateLoading,
    disable: disable,
    enable: enable
  }];
};

export { useAsyncLoading };
//# sourceMappingURL=index.modern.js.map
